
/******************************************************************************
* MODULE     : keyw_until.cc
* DESCRIPTION: until statement in loops
* COPYRIGHT  : (C) 2000  Joris van der Hoeven
*******************************************************************************
* This software falls under the GNU general public license and comes WITHOUT
* ANY WARRANTY WHATSOEVER. See the file $TEXMACS_PATH/LICENSE for more details.
* If you don't have this file, write to the Free Software Foundation, Inc.,
* 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
******************************************************************************/

#include <evaluator.hh>
#include <single.hh>
#include <xtable.hh>
namespace mmx {

void
evaluator_rep::kw_until_1 () {
  // INPUT: (until_1, cond, other_conds, cont, ...)
  if (as_bool (as_value (car (rem)) -> val)) {
    env= as_xtable (env)->base_t;
    cur= caddr (rem);
    rem= cons (VAL_NONE, cdddr (rem));
    // OUTPUT: (cont, void, ...)
    trace= cdr (trace);
  }
  else {
    cur= KW_LOOP_4;
    rem= cdr (rem);
    // OUTPUT: (loop_4, cond_list, cont, ...)
  }
}

} // namespace mmx
